diff --git a/oflog/libsrc/hierlock.cc b/oflog/libsrc/hierlock.cc
index 98d358b..1f3de4e 100644
--- a/oflog/libsrc/hierlock.cc
+++ b/oflog/libsrc/hierlock.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -19,17 +19,20 @@
 // limitations under the License.
 
 #include "dcmtk/oflog/hierlock.h"
+#include "dcmtk/oflog/hierarchy.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/spi/logimpl.h"
+#include "dcmtk/oflog/thread/syncpub.h"
 
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
-
+namespace dcmtk
+{
+namespace log4cplus
+{
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::HierarchyLocker ctor and dtor
+// HierarchyLocker ctor and dtor
 //////////////////////////////////////////////////////////////////////////////
 
 HierarchyLocker::HierarchyLocker(Hierarchy& _h)
@@ -41,33 +44,39 @@ HierarchyLocker::HierarchyLocker(Hierarchy& _h)
     h.initializeLoggerList(loggerList);
 
     // Lock all of the Hierarchy's Loggers' mutexs
-    try {
-            for(LoggerListIterator it=loggerList.begin(); it!=loggerList.end(); ++it) {
-                DCMTK_LOG4CPLUS_MUTEX_LOCK( (*it).value->appender_list_mutex ) ;
-            }
-        }
-        catch(...) {
-            h.getLogLog().error(DCMTK_LOG4CPLUS_TEXT("HierarchyLocker::ctor()- An error occurred while locking"));
-            // TODO --> We need to unlock any Logger mutex that we were able to lock
-            throw;
-        }
+    LoggerList::iterator it;
+    try
+    {
+        for (it = loggerList.begin(); it != loggerList.end(); ++it)
+            it->value->appender_list_mutex.lock ();
     }
-
-
-    HierarchyLocker::~HierarchyLocker()
+    catch (...)
     {
-        try {
-            for(LoggerListIterator it=loggerList.begin(); it!=loggerList.end(); ++it) {
-            DCMTK_LOG4CPLUS_MUTEX_UNLOCK( (*it).value->appender_list_mutex ) ;
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT("HierarchyLocker::ctor()")
+            DCMTK_LOG4CPLUS_TEXT("- An error occurred while locking"));
+        LoggerList::iterator range_end = it;
+        for (it = loggerList.begin (); it != range_end; ++it)
+            it->value->appender_list_mutex.unlock ();
+        throw;
+    }
+}
+ 
+
+HierarchyLocker::~HierarchyLocker()
+{
+    try {
+        for(LoggerList::iterator it=loggerList.begin(); it!=loggerList.end(); ++it) {
+            it->value->appender_list_mutex.unlock ();
         }
     }
     catch(...) {
-        h.getLogLog().error(DCMTK_LOG4CPLUS_TEXT("HierarchyLocker::dtor()- An error occurred while unlocking"));
+        helpers::getLogLog().error(DCMTK_LOG4CPLUS_TEXT("HierarchyLocker::dtor()- An error occurred while unlocking"));
         throw;
     }
 }
 
-void
+void 
 HierarchyLocker::resetConfiguration()
 {
     Logger root = h.getRoot();
@@ -80,45 +89,49 @@ HierarchyLocker::resetConfiguration()
     root.removeAllAppenders();
 
     // repeat
-    for(LoggerListIterator it=loggerList.begin(); it!=loggerList.end(); ++it) {
-        DCMTK_LOG4CPLUS_MUTEX_UNLOCK( (*it).value->appender_list_mutex ) ;
-        (*it).closeNestedAppenders();
-        (*it).removeAllAppenders();
-        DCMTK_LOG4CPLUS_MUTEX_LOCK( (*it).value->appender_list_mutex ) ;
-        (*it).setLogLevel(NOT_SET_LOG_LEVEL);
-        (*it).setAdditivity(true);
+    for(LoggerList::iterator it=loggerList.begin(); it!=loggerList.end(); ++it)
+    {
+        Logger & logger = *it;
+        
+        logger.closeNestedAppenders();
+        logger.removeAllAppenders();
+        
+        logger.setLogLevel(NOT_SET_LOG_LEVEL);
+        logger.setAdditivity(true);
     }
 }
 
 
-Logger
+Logger 
 HierarchyLocker::getInstance(const tstring& name)
 {
     return h.getInstanceImpl(name, *h.getLoggerFactory());
 }
 
 
-Logger
+Logger 
 HierarchyLocker::getInstance(const tstring& name, spi::LoggerFactory& factory)
 {
     return h.getInstanceImpl(name, factory);
 }
 
 
-void
+void 
 HierarchyLocker::addAppender(Logger& logger, SharedAppenderPtr& appender)
 {
-    for(LoggerListIterator it=loggerList.begin(); it!=loggerList.end(); ++it) {
+    for(LoggerList::iterator it=loggerList.begin(); it!=loggerList.end(); ++it) {
         if((*it).value == logger.value) {
-            DCMTK_LOG4CPLUS_MUTEX_UNLOCK( logger.value->appender_list_mutex );
+            logger.value->appender_list_mutex.unlock ();
             logger.addAppender(appender);
-            DCMTK_LOG4CPLUS_MUTEX_LOCK( logger.value->appender_list_mutex );
+            logger.value->appender_list_mutex.lock ();
             return;
         }
     }
-
+    
     // I don't have this Logger locked
     logger.addAppender(appender);
 }
 
 
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/layout.cc b/oflog/libsrc/layout.cc
index d40fe4c..13094ed 100644
--- a/oflog/libsrc/layout.cc
+++ b/oflog/libsrc/layout.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -22,83 +22,137 @@
 #include "dcmtk/oflog/helpers/strhelp.h"
 #include "dcmtk/oflog/helpers/timehelp.h"
 #include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include <ostream>
+#include <iomanip>
 
 
-using namespace std;
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
-using namespace dcmtk::log4cplus::spi;
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+void formatRelativeTimestamp (log4cplus::tostream & output,
+    log4cplus::spi::InternalLoggingEvent const & event);
+
+void
+formatRelativeTimestamp (log4cplus::tostream & output,
+    log4cplus::spi::InternalLoggingEvent const & event)
+{
+    helpers::Time const rel_time
+        = event.getTimestamp () - getTTCCLayoutTimeBase ();
+    tchar const old_fill = output.fill ();
+    time_t const sec = rel_time.sec ();
+ 
+    if (sec != 0)
+        output << sec << STD_NAMESPACE setfill (DCMTK_LOG4CPLUS_TEXT ('0')) << STD_NAMESPACE setw (3);
+ 
+    output << rel_time.usec () / 1000;
+    output.fill (old_fill);
+}
+
+//
+//
+//
+
+
+Layout::Layout ()
+    : llmCache(getLogLevelManager())
+{ }
+
+
+Layout::Layout (const log4cplus::helpers::Properties&)
+    : llmCache(getLogLevelManager())
+{ }
+
+
+Layout::~Layout()
+{ }
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::SimpleLayout public methods
+// log4cplus::SimpleLayout public methods
 ///////////////////////////////////////////////////////////////////////////////
 
+SimpleLayout::SimpleLayout ()
+{ }
+
+
+SimpleLayout::SimpleLayout (const helpers::Properties& properties)
+    : Layout (properties)
+{ }
+
+
+SimpleLayout::~SimpleLayout()
+{ }
+
+
 void
-SimpleLayout::formatAndAppend(tostream& output,
-                              const InternalLoggingEvent& event)
+SimpleLayout::formatAndAppend(log4cplus::tostream& output, 
+                              const log4cplus::spi::InternalLoggingEvent& event)
 {
-    output << llmCache.toString(event.getLogLevel())
+    output << llmCache.toString(event.getLogLevel()) 
            << DCMTK_LOG4CPLUS_TEXT(" - ")
-           << event.getMessage()
+           << event.getMessage() 
            << DCMTK_LOG4CPLUS_TEXT("\n");
 }
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::TTCCLayout ctors and dtor
+// log4cplus::TTCCLayout ctors and dtor
 ///////////////////////////////////////////////////////////////////////////////
 
 TTCCLayout::TTCCLayout(bool use_gmtime_)
-: dateFormat( DCMTK_LOG4CPLUS_TEXT("%m-%d-%y %H:%M:%S,%q") ),
-  use_gmtime(use_gmtime_)
+    : dateFormat()
+    , use_gmtime(use_gmtime_)
 {
 }
 
 
-TTCCLayout::TTCCLayout(const Properties& properties, tstring&)
-: Layout(properties),
-  dateFormat( DCMTK_LOG4CPLUS_TEXT("%m-%d-%y %H:%M:%S,%q") ),
-  use_gmtime(false)
+TTCCLayout::TTCCLayout(const log4cplus::helpers::Properties& properties)
+    : Layout(properties)
+    , dateFormat(properties.getProperty (DCMTK_LOG4CPLUS_TEXT("DateFormat"),
+            internal::empty_str))
+    , use_gmtime(false)
 {
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("DateFormat") )) {
-        dateFormat  = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("DateFormat") );
-    }
-
-    tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("Use_gmtime") );
-    use_gmtime = (toLower(tmp) == DCMTK_LOG4CPLUS_TEXT("true"));
+    properties.getBool (use_gmtime, DCMTK_LOG4CPLUS_TEXT("Use_gmtime"));
 }
 
 
 TTCCLayout::~TTCCLayout()
-{
-}
+{ }
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::TTCCLayout public methods
+// log4cplus::TTCCLayout public methods
 ///////////////////////////////////////////////////////////////////////////////
 
 void
-TTCCLayout::formatAndAppend(tostream& output,
-                            const InternalLoggingEvent& event)
+TTCCLayout::formatAndAppend(log4cplus::tostream& output, 
+                            const log4cplus::spi::InternalLoggingEvent& event)
 {
-    output << event.getTimestamp().getFormattedTime(dateFormat, use_gmtime)
-           << DCMTK_LOG4CPLUS_TEXT(" [")
+     if (dateFormat.empty ())
+         formatRelativeTimestamp (output, event);
+     else
+         output << event.getTimestamp().getFormattedTime(dateFormat,
+             use_gmtime);
+
+    output << DCMTK_LOG4CPLUS_TEXT(" [")
            << event.getThread()
            << DCMTK_LOG4CPLUS_TEXT("] ")
-           << llmCache.toString(event.getLogLevel())
+           << llmCache.toString(event.getLogLevel()) 
            << DCMTK_LOG4CPLUS_TEXT(" ")
            << event.getLoggerName()
            << DCMTK_LOG4CPLUS_TEXT(" <")
-           << event.getNDC()
+           << event.getNDC() 
            << DCMTK_LOG4CPLUS_TEXT("> - ")
            << event.getMessage()
            << DCMTK_LOG4CPLUS_TEXT("\n");
 }
 
 
-
-
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/lloguser.cc b/oflog/libsrc/lloguser.cc
index b878444..0555718 100644
--- a/oflog/libsrc/lloguser.cc
+++ b/oflog/libsrc/lloguser.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,63 +18,38 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-#include "dcmtk/oflog/streams.h"
 #include "dcmtk/oflog/helpers/lloguser.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 
-using namespace std;
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
 
-typedef SharedObjectPtr<LogLog> LogLogPtr;
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
 
-
-///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::LogLogUser ctor and dtor
-///////////////////////////////////////////////////////////////////////////////
-
 LogLogUser::LogLogUser()
-{
-    loglogRef = new SharedObjectPtr<LogLog>(LogLog::getLogLog());
-}
+{ }
 
 
-LogLogUser::LogLogUser(const LogLogUser& rhs)
-{
-    loglogRef = new SharedObjectPtr<LogLog>(*OFstatic_cast(LogLogPtr*, rhs.loglogRef));
-}
+LogLogUser::LogLogUser(const LogLogUser&)
+{ }
 
 
 LogLogUser::~LogLogUser()
-{
-    delete OFstatic_cast(LogLogPtr*, loglogRef);
-}
-
+{ }
 
 
-///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::LogLogUser public methods
-///////////////////////////////////////////////////////////////////////////////
-
 LogLog&
 LogLogUser::getLogLog() const
 {
-    LogLogPtr* ptr = OFstatic_cast(LogLogPtr*, loglogRef);
-    return **ptr;
+    return *LogLog::getLogLog ();
 }
 
 
 LogLogUser&
-LogLogUser::operator=(const LogLogUser& rhs)
+LogLogUser::operator=(const LogLogUser&)
 {
-    if(this == &rhs) {
-        return *this;
-    }
-
-    delete OFstatic_cast(LogLogPtr*, loglogRef);
-    loglogRef = new SharedObjectPtr<LogLog>(*OFstatic_cast(LogLogPtr*, rhs.loglogRef));
-
     return *this;
 }
 
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/lockfile.cc b/oflog/libsrc/lockfile.cc
new file mode 100644
index 0000000..94e1eb5
--- /dev/null
+++ b/oflog/libsrc/lockfile.cc
@@ -0,0 +1,338 @@
+// -*- C++ -*-
+//
+//  Copyright (C) 2012, Vaclav Zeman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H)
+#include <sys/types.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYS_STAT_H)
+#include <sys/stat.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYS_FILE_H)
+#include <sys/file.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_SYS_LOCKING_H)
+#include <sys/locking.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_UNISTD_H)
+#include <unistd.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_FCNTL_H)
+#include <fcntl.h>
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_IO_H)
+#include <io.h>
+#endif
+#if defined (_WIN32)
+#include <tchar.h>
+#include <share.h>
+#endif
+#include "dcmtk/oflog/config/windowsh.h"
+
+#include <stdexcept>
+#include <cerrno>
+#include <limits>
+#include <cstring>
+
+#include "dcmtk/oflog/helpers/lockfile.h"
+#include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+
+#if defined (_WIN32)
+#  if _WIN32_WINNT < 0x0501
+#    define DCMTK_LOG4CPLUS_USE_WIN32_LOCKING
+#  else
+#    define DCMTK_LOG4CPLUS_USE_WIN32_LOCKFILEEX
+#  endif
+#else
+#  if defined (O_EXLOCK)
+#    define DCMTK_LOG4CPLUS_USE_O_EXLOCK
+#  elif defined (DCMTK_LOG4CPLUS_HAVE_FCNTL) && defined (F_SETLKW)
+#    define DCMTK_LOG4CPLUS_USE_SETLKW
+#  elif defined (DCMTK_LOG4CPLUS_HAVE_LOCKF)
+#    define DCMTK_LOG4CPLUS_USE_LOCKF
+#  elif defined (DCMTK_LOG4CPLUS_HAVE_FLOCK)
+#    define DCMTK_LOG4CPLUS_USE_FLOCK
+#  endif
+#  if defined (DCMTK_LOG4CPLUS_USE_O_EXLOCK) || defined (DCMTK_LOG4CPLUS_USE_SETLKW) \
+    || defined (DCMTK_LOG4CPLUS_USE_LOCKF) || defined (DCMTK_LOG4CPLUS_USE_FLOCK)
+#    define DCMTK_LOG4CPLUS_USE_POSIX_LOCKING
+#  endif
+#endif
+
+#if ! defined (DCMTK_LOG4CPLUS_USE_POSIX_LOCKING) && ! defined (_WIN32)
+#error "no usable file locking"
+#endif
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
+
+
+#if defined (_WIN32)
+int const OPEN_FLAGS = _O_RDWR | _O_CREAT /*| _O_TEMPORARY*/ | _O_NOINHERIT;
+int const OPEN_SHFLAGS = _SH_DENYNO;
+int const OPEN_MODE = _S_IREAD | _S_IWRITE;
+
+namespace
+{
+
+static
+HANDLE
+get_os_HANDLE (int fd, helpers::LogLog & loglog)
+{
+    HANDLE fh = OFreinterpret_cast(HANDLE, _get_osfhandle (fd));
+    if (fh == INVALID_HANDLE_VALUE)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT ("_get_osfhandle() failed: "))
+            + convertIntegerToString (errno), true);
+
+    return fh;
+}
+
+} // namespace
+
+#elif defined (DCMTK_LOG4CPLUS_USE_POSIX_LOCKING)
+int const OPEN_FLAGS = O_RDWR | O_CREAT
+#if defined (O_CLOEXEC)
+    | O_CLOEXEC
+#endif
+    ;
+
+mode_t const OPEN_MODE = (S_IRWXU ^ S_IXUSR)
+    | (S_IRWXG ^ S_IXGRP)
+    | (S_IRWXO ^ S_IXOTH);
+
+#endif
+
+struct LockFile::Impl
+{
+#if defined (DCMTK_LOG4CPLUS_USE_POSIX_LOCKING) \
+    || defined (_WIN32)
+    int fd;
+
+#endif
+};
+
+
+//
+//
+//
+
+LockFile::LockFile (tstring const & lf)
+    : lock_file_name (lf)
+    , data (new LockFile::Impl)
+{
+#if defined (DCMTK_LOG4CPLUS_USE_O_EXLOCK)
+    data->fd = -1;
+
+#else
+    open (OPEN_FLAGS);
+
+#endif
+}
+
+
+LockFile::~LockFile ()
+{
+    close ();
+    delete data;
+}
+
+
+void
+LockFile::open (int open_flags) const
+{
+    LogLog & loglog = getLogLog ();
+
+#if defined (_WIN32)
+    data->fd = _sopen (lock_file_name.c_str (), open_flags,
+        OPEN_SHFLAGS, OPEN_MODE);
+    if (data->fd == -1)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT("could not open or create file "))
+            + lock_file_name, true);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_POSIX_LOCKING)
+    data->fd = ::open (DCMTK_LOG4CPLUS_TSTRING_TO_STRING (lock_file_name).c_str (),
+        open_flags, OPEN_MODE);
+    if (data->fd == -1)
+        loglog.error (
+            tstring (DCMTK_LOG4CPLUS_TEXT ("could not open or create file "))
+            + lock_file_name, true);
+
+#if ! defined (O_CLOEXEC) && defined (FD_CLOEXEC)
+    int ret = fcntl (data->fd, F_SETFD, FD_CLOEXEC);
+    if (ret == -1)
+        loglog.warn (
+            tstring (DCMTK_LOG4CPLUS_TEXT("could not set FD_CLOEXEC on file "))
+            + lock_file_name);
+
+#endif
+#endif
+}
+
+
+void
+LockFile::close () const
+{
+#if defined (_WIN32)
+    if (data->fd >= 0)
+        _close (data->fd);
+
+    data->fd = -1;
+
+#elif defined (DCMTK_LOG4CPLUS_USE_POSIX_LOCKING)
+    if (data->fd >= 0)
+        ::close (data->fd);
+
+    data->fd = -1;
+
+#endif
+}
+
+
+void
+LockFile::lock () const
+{
+    LogLog & loglog = getLogLog ();
+    int ret = 0;
+    (void) loglog;
+    (void) ret;
+
+#if defined (DCMTK_LOG4CPLUS_USE_WIN32_LOCKFILEEX)
+    HANDLE fh = get_os_HANDLE (data->fd, loglog);
+
+    OVERLAPPED overlapped;
+    memset (&overlapped, 0, sizeof (overlapped));
+    overlapped.hEvent = 0;
+
+    ret = LockFileEx(fh, LOCKFILE_EXCLUSIVE_LOCK, 0,
+        (STD_NAMESPACE numeric_limits<DWORD>::max) (),
+        (STD_NAMESPACE numeric_limits<DWORD>::max) (), &overlapped);
+    if (! ret)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT ("LockFileEx() failed: "))
+            + convertIntegerToString (GetLastError ()), true);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_LOCKING)
+    ret = _locking (data->fd, _LK_LOCK, (STD_NAMESPACE numeric_limits<long>::max) ());
+    if (ret != 0)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT ("_locking() failed: "))
+            + convertIntegerToString (errno), true);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_O_EXLOCK)
+    open (OPEN_FLAGS | O_EXLOCK);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_SETLKW)
+    do
+    {
+        struct flock fl;
+        fl.l_type = F_WRLCK;
+        fl.l_whence = SEEK_SET;
+        fl.l_start = 0;
+        fl.l_len = 0;
+        ret = fcntl (data->fd, F_SETLKW, &fl);
+        if (ret == -1 && errno != EINTR)
+            loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT("fcntl(F_SETLKW) failed: "))
+                + convertIntegerToString (errno), true);
+    }
+    while (ret == -1);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_LOCKF)
+    do
+    {
+        ret = lockf (data->fd, F_LOCK, 0);
+        if (ret == -1 && errno != EINTR)
+            loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT("lockf() failed: "))
+                + convertIntegerToString (errno), true);
+    }
+    while (ret == -1);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_FLOCK)
+    do
+    {
+        ret = flock (data->fd, LOCK_EX);
+        if (ret == -1 && errno != EINTR)
+            loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT("flock() failed: "))
+                + convertIntegerToString (errno), true);
+    }
+    while (ret == -1);
+
+#endif
+}
+
+
+void LockFile::unlock () const
+{
+    LogLog & loglog = getLogLog ();
+    int ret = 0;
+
+#if defined (DCMTK_LOG4CPLUS_USE_WIN32_LOCKFILEEX)
+    HANDLE fh = get_os_HANDLE (data->fd, loglog);
+
+    ret = UnlockFile(fh, 0, 0, (STD_NAMESPACE numeric_limits<DWORD>::max) (),
+        (STD_NAMESPACE numeric_limits<DWORD>::max) ());
+    if (! ret)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT ("UnlockFile() failed: "))
+            + convertIntegerToString (GetLastError ()), true);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_LOCKING)
+    ret = _locking (data->fd, _LK_UNLCK, (STD_NAMESPACE numeric_limits<long>::max) ());
+    if (ret != 0)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT ("_locking() failed: "))
+            + convertIntegerToString (errno), true);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_O_EXLOCK)
+    close ();
+
+#elif defined (DCMTK_LOG4CPLUS_USE_SETLKW)
+    struct flock fl;
+    fl.l_type = F_UNLCK;
+    fl.l_whence = SEEK_SET;
+    fl.l_start = 0;
+    fl.l_len = 0;
+    ret = fcntl (data->fd, F_SETLKW, &fl);
+    if (ret != 0)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT("fcntl(F_SETLKW) failed: "))
+            + convertIntegerToString (errno), true);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_LOCKF)
+    ret = lockf (data->fd, F_ULOCK, 0);
+    if (ret != 0)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT("lockf() failed: "))
+            + convertIntegerToString (errno), true);
+
+#elif defined (DCMTK_LOG4CPLUS_USE_FLOCK)
+    ret = flock (data->fd, LOCK_UN);
+    if (ret != 0)
+        loglog.error (tstring (DCMTK_LOG4CPLUS_TEXT("flock() failed: "))
+            + convertIntegerToString (errno), true);
+
+#endif
+
+}
+
+
+
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/log4judp.cc b/oflog/libsrc/log4judp.cc
new file mode 100644
index 0000000..7128b42
--- /dev/null
+++ b/oflog/libsrc/log4judp.cc
@@ -0,0 +1,263 @@
+// Module:  Log4CPLUS
+// File:    log4judpappender.cxx
+// Created: 7/2012
+// Author:  Siva Chandran P
+//
+//
+// Copyright 2012 Siva Chandran P
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+#include "dcmtk/oflog/log4judp.h"
+#include "dcmtk/oflog/layout.h"
+#include "dcmtk/oflog/streams.h"
+#include "dcmtk/oflog/logmacro.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include "dcmtk/oflog/thread/syncpub.h"
+#include <iomanip>
+#include <cstring>
+#if defined (UNICODE)
+#include <cwctype>
+#else
+#include <cctype>
+#endif
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+namespace
+{
+
+
+static inline bool
+is_control (tchar ch)
+{
+#if defined (UNICODE)
+    return !! STD_NAMESPACE iswcntrl (STD_NAMESPACE char_traits<tchar>::to_int_type (ch));
+#elif defined (_MSC_VER) && _MSC_VER <= 1200 /* MSC6 and older */
+    return !! iscntrl (STD_NAMESPACE char_traits<tchar>::to_int_type (ch));
+#else
+    return !! STD_NAMESPACE iscntrl (STD_NAMESPACE char_traits<tchar>::to_int_type (ch));
+#endif
+}
+
+
+//! Outputs str with reserved XML characters escaped.
+static
+void
+output_xml_escaped (tostream & os, tstring const & str)
+{
+    for (tstring::const_iterator it = str.begin (); it != str.end (); ++it)
+    {
+        tchar const & ch = *it;
+        switch (ch)
+        {
+        case DCMTK_LOG4CPLUS_TEXT ('<'):
+            os << DCMTK_LOG4CPLUS_TEXT ("&lt;");
+            break;
+
+        case DCMTK_LOG4CPLUS_TEXT ('>'):
+            os << DCMTK_LOG4CPLUS_TEXT ("&gt;");
+            break;
+
+        case DCMTK_LOG4CPLUS_TEXT ('&'):
+            os << DCMTK_LOG4CPLUS_TEXT ("&amp;");
+            break;
+
+        case DCMTK_LOG4CPLUS_TEXT ('\''):
+            os << DCMTK_LOG4CPLUS_TEXT ("&apos;");
+            break;
+
+        case DCMTK_LOG4CPLUS_TEXT ('"'):
+            os << DCMTK_LOG4CPLUS_TEXT ("&quot;");
+            break;
+
+        default:
+            if (is_control (ch))
+            {
+                tchar const prev_fill = os.fill ();
+                STD_NAMESPACE ios_base::fmtflags const prev_flags = os.flags ();
+                os.flags (STD_NAMESPACE ios_base::hex | STD_NAMESPACE ios_base::right);
+                os.fill (DCMTK_LOG4CPLUS_TEXT ('0'));
+
+                os << STD_NAMESPACE setw (0) << DCMTK_LOG4CPLUS_TEXT ("&#x")
+                    << STD_NAMESPACE setw (2) << STD_NAMESPACE char_traits<tchar>::to_int_type (ch)
+                    << STD_NAMESPACE setw (0) << DCMTK_LOG4CPLUS_TEXT (";");
+
+                os.fill (prev_fill);
+                os.flags (prev_flags);
+            }
+            else
+                os.put (ch);
+        }
+    }
+}
+
+
+//! Helper manipulator like class for escaped XML output.
+struct outputXMLEscaped
+{
+    outputXMLEscaped (tstring const & s)
+        : str (s)
+    { }
+
+    tstring const & str;
+};
+
+
+//! Overload stream insertion for outputXMLEscaped.
+static
+tostream &
+operator << (tostream & os, outputXMLEscaped const & x)
+{
+    output_xml_escaped (os, x.str);
+    return os;
+}
+
+
+} // namespace
+
+
+//////////////////////////////////////////////////////////////////////////////
+// Log4jUdpAppender ctors and dtor
+//////////////////////////////////////////////////////////////////////////////
+
+Log4jUdpAppender::Log4jUdpAppender(const tstring& host_, int port_)
+    : socket()
+    , host(host_)
+    , port(port_)
+{
+    layout.reset (new PatternLayout (DCMTK_LOG4CPLUS_TEXT ("%m")));
+    openSocket();
+}
+
+
+
+Log4jUdpAppender::Log4jUdpAppender(const helpers::Properties & properties)
+    : Appender(properties)
+    , socket()
+    , host()
+    , port(5000)
+{
+    host = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("host"),
+        DCMTK_LOG4CPLUS_TEXT ("localhost") );
+    properties.getInt (port, DCMTK_LOG4CPLUS_TEXT ("port"));
+
+    openSocket();
+}
+
+
+
+Log4jUdpAppender::~Log4jUdpAppender()
+{
+    destructorImpl();
+}
+
+
+
+//////////////////////////////////////////////////////////////////////////////
+// Log4jUdpAppender public methods
+//////////////////////////////////////////////////////////////////////////////
+
+void 
+Log4jUdpAppender::close()
+{
+    helpers::getLogLog().debug(
+        DCMTK_LOG4CPLUS_TEXT("Entering Log4jUdpAppender::close()..."));
+
+    socket.close();
+    closed = true;
+}
+
+
+
+//////////////////////////////////////////////////////////////////////////////
+// Log4jUdpAppender protected methods
+//////////////////////////////////////////////////////////////////////////////
+
+void
+Log4jUdpAppender::openSocket()
+{
+    if(!socket.isOpen()) {
+        socket = helpers::Socket(host, port, true);
+    }
+}
+
+void
+Log4jUdpAppender::append(const spi::InternalLoggingEvent& event)
+{
+    if(!socket.isOpen()) {
+        openSocket();
+        if(!socket.isOpen()) {
+            helpers::getLogLog().error(
+                DCMTK_LOG4CPLUS_TEXT("Log4jUdpAppender::append()- Cannot connect to server"));
+            return;
+        }
+    }
+
+    tstring & str = formatEvent (event);
+
+    internal::appender_sratch_pad & appender_sp
+        = internal::get_appender_sp ();
+    tostringstream & buffer = appender_sp.oss;
+    detail::clear_tostringstream (buffer);
+
+    buffer << DCMTK_LOG4CPLUS_TEXT("<log4j:event logger=\"")
+           << outputXMLEscaped (event.getLoggerName())
+           << DCMTK_LOG4CPLUS_TEXT("\" level=\"")
+           // TODO: Some escaping of special characters is needed here.
+           << outputXMLEscaped (getLogLevelManager().toString(event.getLogLevel()))
+           << DCMTK_LOG4CPLUS_TEXT("\" timestamp=\"")
+           << event.getTimestamp().getFormattedTime(DCMTK_LOG4CPLUS_TEXT("%s%q"))
+           << DCMTK_LOG4CPLUS_TEXT("\" thread=\"") << event.getThread()
+           << DCMTK_LOG4CPLUS_TEXT("\">")
+
+           << DCMTK_LOG4CPLUS_TEXT("<log4j:message>")
+           // TODO: Some escaping of special characters is needed here.
+           << outputXMLEscaped (str)
+           << DCMTK_LOG4CPLUS_TEXT("</log4j:message>")
+
+           << DCMTK_LOG4CPLUS_TEXT("<log4j:NDC>")
+           // TODO: Some escaping of special characters is needed here.
+           << outputXMLEscaped (event.getNDC())
+           << DCMTK_LOG4CPLUS_TEXT("</log4j:NDC>")
+
+           << DCMTK_LOG4CPLUS_TEXT("<log4j:locationInfo class=\"\" file=\"")
+           // TODO: Some escaping of special characters is needed here.
+           << outputXMLEscaped (event.getFile())
+           << DCMTK_LOG4CPLUS_TEXT("\" method=\"")
+           << outputXMLEscaped (event.getFunction())
+           << DCMTK_LOG4CPLUS_TEXT("\" line=\"")
+           << event.getLine()
+           << DCMTK_LOG4CPLUS_TEXT("\"/>")
+           << DCMTK_LOG4CPLUS_TEXT("</log4j:event>");
+
+    DCMTK_LOG4CPLUS_TSTRING_TO_STRING (buffer.str ()).swap (appender_sp.chstr);
+
+    bool ret = socket.write(appender_sp.chstr);
+    if (!ret)
+    {
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT(
+                "Log4jUdpAppender::append()- Cannot write to server"));
+    }
+}
+
+} // namespace log4cplus
+} // end namespace dcmtk
